export function loadData(_this){
	var time = new Date();
	_this.$http.post(_this.URL_PARAM.API + "/activityArea/detail-xmArea",
		{
			linkId	: _this.getLinkId(),
			isHide	: _this.getIsHide(),
		},
		{emulateJSON:true}).then(function(response) {
		var l = new Date().getTime()-time.getTime();
		if (window._czc) {  
		    window._czc.push([
		    	_this.$store.state.umParams.trackEvent, 
		    	_this.$store.state.umParams.event.activityArea.xmArea.category, 
		    	_this.$store.state.umParams.event.activityArea.xmArea.action, 
		    	_this.$store.state.umParams.event.activityArea.xmArea.label,
		    	l,'']);
		} 
		if(!response.data.success){
			showMsg(_this,response.data.info,"warning");
			return ;
		}
		this.user = response.data.user;
		setWeek(response.data,_this);
		setLimit(response.data,_this);
		_this.onload();
	});
}
function setWeek(data,_this){
	if(data.weekFree == null){
		return ;
	}
	if(_this.$store.getters.getIsSpecDate){
		//是特殊时间
		specWeek(data,_this);
		return 
	}
	comonWeek(data,_this);
}
//周免特殊时间段分级显示
function specWeek(data,_this){
	if(data.weekFree.vo == null || data.weekFree.vo.length <= 0 ){
		return ;
	}
	_this.weekReadCoins = _this.$store.state.specCoins.first;
	_this.week.startDate = data.weekFree.startDate;
	_this.week.endDate = data.weekFree.endDate;
	if(data.weekFree.vo.length <= _this.$store.state.specLevel.first){
		_this.weekFree = data.weekFree.vo;
		//_this.weekReadCoins = data.weekFree.readCoins;
		if(!timeValidator(data.weekFree.endDate+" 23:59:59")){
			_this.weekState = "";
			weekTimeLeave(_this,data.weekFree.endDate);
		}
		return ;
	}
	
	if(data.weekFree.vo.length >= _this.$store.state.specLevel.first ){
		_this.secReadCoins = _this.$store.state.specCoins.second;
	}
	if(data.weekFree.vo.length >= _this.$store.state.specLevel.second ){
		_this.thirdReadCoins = _this.$store.state.specCoins.third;
	}
	var secWeek = [];
	var thirdWeek = [];
	_this.weekTitle =  data.weekFree.title;
	for(var i = 0 ; i < data.weekFree.vo.length;i++){
		var comic = data.weekFree.vo[i];
		if(i < _this.$store.state.specLevel.first){
			_this.weekFree.push(comic);
			secWeek.push(comic);
			thirdWeek.push(comic);
			continue;
		}
		if(i < _this.$store.state.specLevel.second){
			secWeek.push(comic);
			thirdWeek.push(comic);
			continue;
		}
		thirdWeek.push(comic);;
	}
	if(secWeek != null && secWeek.length > 0){
		secWeek.reverse();
	}
	if(thirdWeek != null && thirdWeek.length > 0){
		thirdWeek.reverse();
	}
	_this.secWeek = secWeek;
	_this.thirdWeek = thirdWeek;
	if(!timeValidator(data.weekFree.endDate+" 23:59:59")){
		_this.weekState = "";
		weekTimeLeave(_this,data.weekFree.endDate);
	}
	
}
//周免正常时间段显示
function comonWeek(data,_this){
	_this.weekFree = data.weekFree.vo;
	_this.weekReadCoins = data.weekFree.readCoins;
	_this.weekTitle =  data.weekFree.title;
	_this.week.startDate = data.weekFree.startDate;
	_this.week.endDate = data.weekFree.endDate;
	if(!timeValidator(data.weekFree.endDate+" 23:59:59")){
		_this.weekState = "";
		weekTimeLeave(_this,data.weekFree.endDate);
	}
}

//设置限时限免的活动
function setLimit(data,_this){
	var endDate = "";
	var startDate = "";
	var startTime = "";
	var endTime = "";
	if(data.limitFree != null){
		_this.limitFree = data.limitFree.vo;
		_this.limitReadCoins = data.limitFree.readCoins;
		endDate = data.limitFree.endDate;
		startDate = data.limitFree.startDate;
		endTime = data.limitFree.endTime;
		startTime = data.limitFree.startTime;
	}
	if(data.limitFree != null && !timeValidator(endDate+" "+endTime)){
		_this.limitState = "";
		_this.limit.startDate = startDate;
		_this.limit.endDate = endDate;
		_this.limitTitle =  data.limitFree.title;
		var startDateStr = startDate.split("-");
		var endDateStr = endDate.split("-");
		var startTimeStr = startTime.substring(0,5);
		var endTimeStr = endTime.substring(0,5);
		var dateRange = startDateStr[1]+"月"+startDateStr[2]+"日至"+endDateStr[1]+"月"+endDateStr[2]+"日";
		var timeRange = startTimeStr+"~"+endTimeStr;
		_this.limitText = "限免时间："+dateRange+timeRange;
	}
}


function weekTimeLeave(_this,endDate){
	var setInt = setInterval(function(){
		var datetime = endDate+" 23:59:59";
		var timeleave = _this.timeDiffer(datetime);
		$(".weekLeave").html("距离结束还有："+timeleave);
	},1000);
	_this.setInter = setInt;
}
function timeValidator(value){
	var timestamp = new Date().getTime();
	value = value.replace(/-/g,'/');
	var timestamp1 = new Date(value).getTime();
	return timestamp > timestamp1;
}

function showMsg(_this,msg,type){
	_this.$message({
		showClose: true,
		type: type,
		message:msg 
	});
}