export function loadHotCartoon(_this){
	if(_this.checkUser()){
		getListWeek(_this);
	}else if(_this.type == 0){
		_this.showUnLogin();
		return;
	}
	var onIndex = $(".nav-div").find(".on").index();
	if(_this.params.isEnd ){
		return ;
	}
	_this.loading = true;
	if(_this.params.pageNo != 1){
		$("#load-cover").show();
	}
	var linkId = _this.getLinkId();
	var isHide = _this.getIsHide();
	_this.$http.post(
		_this.URL_PARAM.API + '/cartoonCollection/list-cartoon',
		{
			linkId:linkId,
			startIndex:(_this.params.pageNo-1)*_this.params.pageSize,
			length:_this.params.pageSize,
			checkDate:_this.checkDate,
			type:_this.type,
			isHide:isHide,
		},
		{emulateJSON:true})
		.then(function(response) {
			$("#load-cover").hide();
			if(!response.data.success){
				showMsg(_this,response.data.info,"warning");
				_this.loading = false;
				return ;
			}
			_this.params.startIndex = _this.params.startIndex*_this.params.pageSize+_this.params.pageSize;
			_this.params.isShowEnd = false;
			_this.isShowEmpty = false;
			_this.params.isEnd = false;
			//空数据
			if(_this.list.length <= 0 && response.data.list.length == 0){
				_this.isShowEmpty  = true;
				_this.params.isEnd = true;
				_this.loading = false;
				return ;
			}
			if(response.data.list.length == _this.params.pageSize){
				//有下一页
				var length = _this.params.pageSize-1;
				for(var i = 0 ; i < length ; i++){
					_this.list.push(response.data.list[i]);
				}
				_this.loading = false;
				return ;
			}
			if(response.data.list.length < _this.params.pageSize){
				//没有下一页
				_this.params.isEnd = true;
				if(onIndex != null && onIndex > 0){
					//第一个日期不显示
					_this.params.isShowEnd = true;
				}
				if(onIndex == -1){
					//刚进来
					_this.params.isShowEnd = true;
				}
				var length = response.data.list.length;
				for(var i = 0 ; i < length ; i++){
					_this.list.push(response.data.list[i]);
				}
				_this.loading = false;
				return ;
			}
			_this.loading = false;
			
		});
}




export	function getListWeek(obj){
	var linkId = obj.getLinkId();
	var isHide = obj.getIsHide();
	obj.$http.post(obj.URL_PARAM.API + "/cartoonCollection/list-weekShow",
	{
		linkId:linkId,
		isHide:isHide,
	}
	,{emulateJSON:true}).then(function(pay) {
		if(!pay.data.success){
			this.$message({
				type: 'error',
        		message: pay.data.info
    		})
			return ;
		}
		var count = 0;
		for(var i = 0;i < pay.data.list.length;i++){
			if(pay.data.list[i] == 1){
				count++;
				$('.week-class').eq(i).addClass("active");
			}else{
				$('.week-class').eq(i).removeClass("active");
			}
		}
		if(count == 0){
			$('#headPoint').removeClass("active");
		}else{
			$('#headPoint').addClass("active");
		}
		
		if(obj.type == 0){
		}else{
			$('.week-class').removeClass("active");
		}
	});
}








//初始化日期
export function initWeekList(_this){
	var now = new Date();
	var nowStr = now.Format("yyyy-MM-dd");
	var  weekObj = {
		weekDate:'',
		weekText:''
	};
	var weekArray = ['周一','周二','周三','周四','周五','周六','周日'];
	for(var i = 6 ; i >= 1 ; i--){
		weekObj = {
			weekDate:'',
			weekText:''
		};
		getBeforeDate(weekArray,weekObj,nowStr,i);
		_this.weekList.push(weekObj);
	}
	weekObj = {
		weekDate:'',
		weekText:''
	};
	weekObj.weekText = '今天'; 
	weekObj.weekDate = nowStr; 
	_this.weekList.push(weekObj);
	_this.checkDate = nowStr;

}

function getBeforeDate(weekArray,weekObj,nowStr,i){
    var beforeDate = new Date(nowStr);
    beforeDate.setDate(beforeDate.getDate()-i);
    weekObj.weekDate = beforeDate.Format("yyyy-MM-dd");
    if(i == 1){
    	weekObj.weekText = '昨天';
    	return ;
    }
    var week = beforeDate.getDay(); 
    if(week == 0){
    	week = 6;
    }else{
    	week = week - 1;
    }
	weekObj.weekText = weekArray[week];
}


// 对Date的扩展，将 Date 转化为指定格式的String
// 月(M)、日(d)、小时(h)、分(m)、秒(s)、季度(q) 可以用 1-2 个占位符， 
// 年(y)可以用 1-4 个占位符，毫秒(S)只能用 1 个占位符(是 1-3 位的数字) 
// 例子： 
// (new Date()).Format("yyyy-MM-dd hh:mm:ss.S") ==> 2006-07-02 08:09:04.423 
// (new Date()).Format("yyyy-M-d h:m:s.S")      ==> 2006-7-2 8:9:4.18 
Date.prototype.Format = function (fmt) { //author: meizz 
    var o = {
        "M+": this.getMonth() + 1, //月份 
        "d+": this.getDate(), //日 
        "h+": this.getHours(), //小时 
        "m+": this.getMinutes(), //分 
        "s+": this.getSeconds(), //秒 
        "q+": Math.floor((this.getMonth() + 3) / 3), //季度 
        "S": this.getMilliseconds() //毫秒 
    };
    if (/(y+)/.test(fmt)) fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
    for (var k in o)
    if (new RegExp("(" + k + ")").test(fmt)) fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
    return fmt;
}

//点赞漫画
export function praiseCart(event,_this){
	if($(event).hasClass("disabled")){
		return ;
	}
	$(event).addClass("disabled");
	var cartId = $(event).attr("cart-id");
	var cartIndex = $(event).attr("cart-index");
	_this.$http.post(
		_this.URL_PARAM.API+"/cartoonCollection/praise",
		{
			id:cartId
		},
		{emulateJSON:true}).then(
			function(response) {
				$(event).removeClass("disabled");
				if(!response.data.success){
					showMsg(_this,response.data.info,"warning");
					return ;
				}
				var state = response.data.state;
				//
				$(event).toggleClass("on");
				if(state == 1){
					//点赞成功
					_this.list[cartIndex].shamPraiseCount = _this.list[cartIndex].shamPraiseCount+1;
					_this.list[cartIndex].isPraise = true;
					return ;
				}
				_this.list[cartIndex].shamPraiseCount = _this.list[cartIndex].shamPraiseCount-1;
				_this.list[cartIndex].isPraise = false;
			}
		);
}

function showMsg(_this,msg,type){
	_this.$message({
		showClose: true,
		type: type,
		message:msg 
	});
}