//加载漫画详情
export function detail(_this){
	$("#load-cover").show();
	var linkId = _this.getLinkId();
	var isHide = _this.getIsHide();
	_this.$http.post(_this.URL_PARAM.API + "/cartoonCollection/detail",
		{
			id:_this.id,
			linkId:linkId,
			isHide:isHide,
		},{emulateJSON:true}).then(function(response) {
		$("#load-cover").hide();
		if(!response.data.success){
			showMsg(_this,response.data.info,"warning");
     		return ;
		}
		_this.$bus.$emit("calcByBusUser", 20);
		_this.cartoon = response.data.cartoon;
		if(_this.cartoon.content){
			if(_this.cartoon.content.length > 150){
				_this.cartoonContent = _this.cartoon.content.substring(0,150);
			}else{
				_this.cartoonContent = _this.cartoon.content;
			}
		
		}
		_this.recommends = response.data.recommends;
		_this.isCollect = _this.cartoon.cobrcaId;
		_this.collectText = _this.cartoon.cobrcaId==1?'已收藏':'收藏';
		if(_this.cartoon.isLimit == 1){
			_this.hasActivity = true;
			_this.readCoins = _this.cartoon.freeCoins;
			if(_this.cartoon.freeText == "限时免费  还剩："){
				countdown(_this,_this.cartoon.limitTime)
			}else {
				_this.freeText = _this.cartoon.freeText+" "+_this.cartoon.startDate+"至"+_this.cartoon.endDate;
			}
		}
		var beginChapterId = _this.getReadId();
		if(beginChapterId && beginChapterId != 0 && _this.cartoon.firstChapterId != beginChapterId){
			_this.readText = '继续阅读';
		}
		var user = response.data.user;
		if(null != user){
			window.sessionStorage.setItem('user',JSON.stringify(user));
			_this.payParams.giveCoins = user.giveCoins;
			_this.payParams.readCoins = user.readCoins;
		}
		_this.saveLocalHistory();
	});
}

//静态更新数据漫画详情
export function update(_this){
	_this.$http.post(_this.URL_PARAM.API + "/cartoonCollection/detail",
		{id:_this.id},{emulateJSON:true}).then(function(response) {
		if(!response.data.success){
			showMsg(_this,response.data.info,"warning");
     		return ;
		}
		var cartoon = response.data.cartoon;
		_this.cartoon.browseChapterId = cartoon.browseChapterId
	});
}


//加载漫画的章节数据
export function loadChapter(_this){
	if(_this.getAppstyle()){
		return loadChapterByUser(_this);
	}
	if(window.plus){
		return loadChapterByUuid(_this);
	}
}

function loadChapterByUuid(_this){
	_this.loading = true;
	$("#load-cover").show();
	_this.$http.post(_this.URL_PARAM.API + "/cartoonCollection/list-ios-chapter",
		{
			id:_this.id,
			pageSize:_this.params.pageSize,
    		pageNo:_this.params.pageNo,
    		sort:_this.sort,
    		uuid:plus.device.uuid,
    		linkId:_this.getLinkId()
		},
		{emulateJSON:true}).then(function(response) {
			$("#load-cover").hide();
			if(!response.data.success){
				showMsg(_this,response.data.info,"warning");
				_this.loading = false;
				return ;
			}
			_this.haveNextPage = response.data.haveNextPage;
			if(!_this.haveNextPage){
				_this.isShowEnd = true;
			}
			var length = response.data.list.length - 1;
			if(length < _this.params.pageSize ){
				length = response.data.list.length
			}
			for(var i = 0 ; i < length ; i++){
				_this.chapterList.push(response.data.list[i]);
			}
	    	_this.loading = false;
	});
}

function loadChapterByUser(_this){
	_this.loading = true;
	$("#load-cover").show();
	_this.$http.post(_this.URL_PARAM.API + "/cartoonCollection/list-chapter",
		{
			id:_this.id,
			pageSize:_this.params.pageSize,
    		pageNo:_this.params.pageNo,
    		sort:_this.sort
		},
		{emulateJSON:true}).then(function(response) {
		$("#load-cover").hide();
		if(!response.data.success){
			showMsg(_this,response.data.info,"warning");
			_this.loading = false;
			return ;
		}
		_this.haveNextPage = response.data.haveNextPage;
		if(!_this.haveNextPage){
			_this.isShowEnd = true;
		}
		var length = response.data.list.length - 1;
		if(length < _this.params.pageSize ){
			length = response.data.list.length
		}
		for(var i = 0 ; i < length ; i++){
			_this.chapterList.push(response.data.list[i]);
		}
    	_this.loading = false;
	});
}
//收藏
export function collect(_this,e){
	_this.$http.post(
		_this.URL_PARAM.API+"/cartoonCollection/collect",
		{
			id:_this.id
		},
		{emulateJSON:true}).then(function(response) {
		if(!response.data.success){
			showMsg(_this,response.data.info,"warning");
			return ;
		}
		var state = response.data.state;
		$("#collectionBtn").toggleClass("on");
		_this.taskState = response.data.taskState;
		if(_this.taskState != null  && _this.taskState >= 1){
			_this.taskInfo = '收藏任务完成啦，快去任务中心领取~';
			_this.taskInfoShow();
		}
		if(state == 1){
			//收藏成功
			_this.collectText ="已收藏";
			return ;
		}
		_this.collectText ="收藏";
	});
}
//点赞
export function praise(_this,e){
	_this.$http.post(
		_this.URL_PARAM.API+"/cartoonCollection/praise",
		{
			id:_this.id
		},
		{emulateJSON:true}).then(function(response) {
				if(!response.data.success){
					showMsg(_this,response.data.info,"warning");
					return ;
				}
				var state = response.data.state;
				_this.taskState = response.data.taskState;
				if(_this.taskState != null  && _this.taskState >= 1){
					_this.taskInfo = '点赞任务完成啦，快去任务中心领取~';
					_this.taskInfoShow();
				}
				//
				if(state == 1){
					//点赞成功
					_this.cartoon.shamPraiseCount = _this.cartoon.shamPraiseCount+1;
					_this.cartoon.isPraise = true;
					return ;
				}	//取消点赞
				_this.cartoon.shamPraiseCount = _this.cartoon.shamPraiseCount-1;
				_this.cartoon.isPraise = false;
			}
		);
}

//前往详情
export function goChapter(_this,chapterId,event) {
	//判断是否可以观看
	_this.$router.push('/chapter/detail-chapter/'+chapterId);
	$(event).removeClass("disable");
}
//计算付款
function calPrice(_this){
	_this.payParams.payChapterNum  = 1;
	_this.payParams.payChapterMoney = _this.cartoon.price;
	_this.payParams.payCoins = _this.cartoon.price;
	_this.payParams.state = 0;
	//弹窗信息
	//赠币充足
	if(_this.payParams.giveCoins >= _this.payParams.payChapterMoney){
		_this.payParams.payText = "扣"+_this.payParams.payChapterMoney+"赠币";
		_this.payParams.payGiveCoins = _this.payParams.payChapterMoney;
		return ;
	}
	//赠币不足 
	if(_this.payParams.giveCoins > 0  ){
		var surplus = _this.payParams.payChapterMoney - _this.payParams.giveCoins;
		//阅读币补足
		if( _this.payParams.readCoins >= surplus){
			_this.payParams.payGiveCoins = _this.payParams.giveCoins;
			_this.payParams.payReadCoins = surplus;
			_this.payParams.payText = "扣"+_this.payParams.giveCoins+"赠币   "+surplus+"阅读币";
			return ;
		}
		//阅读币不足
		_this.payParams.payText = "去充值";
		_this.payParams.state = 1;
		return ;
	}
	//无赠币 ，阅读币充足
	if(_this.payParams.readCoins >= _this.payParams.payChapterMoney){
		_this.payParams.payReadCoins = _this.payParams.payChapterMoney;
		_this.payParams.payText = "扣"+_this.payParams.payChapterMoney+"阅读币";
		return ;
	}
	//无赠币、无阅读币
	_this.payParams.payText = "去充值";
	_this.payParams.state = 1;
}
//购买
export function purchase(_this,chapterId,event){
	_this.$http.post(
		_this.URL_PARAM.API+"/orderInfo/new-orderInfo",
		{
			id :_this.id,
			ids :chapterId,
			readCoins :_this.payParams.payReadCoins,
			giveCoins :_this.payParams.payGiveCoins
		},
		{emulateJSON:true}).then(function(response) {
		$(event).removeClass("disable");
		if(!response.data.success){
			showMsg(_this,response.data.info,"warning");
			return ;
		}
		_this.$router.push('/chapter/detail-chapter/'+chapterId);//跳转详情
	});
}
//设置自动购买
export function setAutoPay(_this,event){
	var state = 1;
	if($(event.currentTarget).hasClass("on")){
		state = 0;		
	}
	_this.$http.post(
		_this.URL_PARAM.API+"/cartoonCollection/auto-pay",
		{
			id :_this.id,
			chapterId :_this.params.readChapterId,
			state:state
		},
		{emulateJSON:true}).then(function(response) {
		if(!response.data.success){
			showMsg(_this,response.data.info,"warning");
			return ;
		}
		_this.cartoon.isAutoPay = response.data.isAutoPay;
	});
	
}


//增加点击量
export function addClickNum(_this,linkId){
	_this.$http.post(
		_this.URL_PARAM.API+"/cartoonCollection/add-click-count",
		{
			linkId:linkId
		},
		{emulateJSON:true}).then(
			function(response) {
				if(!response.data.success){
					showMsg(_this,response.data.info,"warning");
					return ;
				}
			}
		);
}




//章节点赞
export function praiseChapter(event,_this){
	if($(event).hasClass("disabled")){
		return ;
	}
	$(event).addClass("disabled");
	var chapterId = $(event).attr("chapter-id");
	var chapterIndex = $(event).attr("chapter-index");
	_this.$http.post(
		_this.URL_PARAM.API+"/chapter/priase",
		{
			id :chapterId
		},
		{emulateJSON:true}).then(function(response) {
		$(event).removeClass("disabled")
		if(!response.data.success){
			showMsg(_this,response.data.info,"warning");
			return ;
		}
		var praiseState = response.data.state;
		if(praiseState == 0){
			_this.chapterList[chapterIndex].shamPraiseCount = _this.chapterList[chapterIndex].shamPraiseCount-1;
			_this.chapterList[chapterIndex].isPraise = false;
			$(event).toggleClass("on");
			return ;
		}
		_this.chapterList[chapterIndex].shamPraiseCount = _this.chapterList[chapterIndex].shamPraiseCount+1;
		_this.chapterList[chapterIndex].isPraise = true;
		$(event).toggleClass("on");
	});
	
}
function showMsg(_this,msg,type){
	_this.$message({
		showClose: true,
		type: type,
		message:msg 
	});
}
var setClock;
//倒计时
function countdown(_this,limitTime) {
   setClock = setInterval(function() {
        var s =  limitTime/ 1e3,
        e = parseInt(s / 3600 / 24),
        t = parseInt((s - 24 * e * 3600) / 3600),
        o = parseInt((s - 24 * e * 3600 - 3600 * t) / 60),
        n = parseInt(s - 24 * e * 3600 - 3600 * t - 60 * o);
        if(e == 0 && t == 0 && o == 0 && n == 0){
        	 _this.freeText = '限时免费 还剩:'+c;
        	 return ;
        }
        limitTime < 0 && (t = 0 - t, o = 0 - o);
        var c = (e<10?'0':'')+ e + "天" + (t<10?'0':'') + t + "时" + (o<10?'0':'') + o + "分" + (n<10?'0':'') + n + "秒";
        _this.freeText = '限时免费 还剩:'+c;
        limitTime -= 1e3
    },
    1e3)
}

export function clearClock(){
	if(setClock != null){
		clearInterval(setClock); //清除js定时器
	}
}

export function updateStatClick(_this,type,url){
	_this.$http.post(_this.URL_PARAM.API + "/index/app-update-stat-click",{type:type},
		{emulateJSON:true}).then(function(response){
		if(!response.data.success){
			showMsg(_this.response.data.info,"warning");
			return;
		}
	});
	_this.$router.push(url);
}

