export	function getSearchKeywords(obj){
	obj.$http.post(obj.URL_PARAM.API + "/cartoonCollection/list-search-keywords"
	,{pageNo:obj.params.pageNo,pageSize:obj.params.pageSize}
	,{emulateJSON:true}).then(function(pay) {
		if(!pay.data.success){
			obj.$message({
				type: 'error',
        		message: pay.data.info
    		})
			return ;
		}
		obj.totalPage = pay.data.totalPage;
		obj.searchHistorys = [];
		obj.hotKeys = [];
		if(pay.data.searchHistorys != null){
			for(var i = 0 ; i < pay.data.searchHistorys.length;i++){
				obj.searchHistorys.push(pay.data.searchHistorys[i]);
			}
		}
		for(var i = 0 ; i < pay.data.hotKeys.length;i++){
			obj.hotKeys.push(pay.data.hotKeys[i]);
		}
		if( pay.data.searchHistorys == null || pay.data.searchHistorys.length <= 0 ){
			$('.history').hide();
		}else{
			$('.history').show();
		}
		obj.loading = false;
	},function(res){
		obj.$message({
			showClose: true,
			type: 'error',
			message:"网络异常，请刷新重试" 
		});
	})
}





export	function getSearchResult(obj,keyword){
	obj.keyword = keyword;
	$('#keyword').val(keyword);
	$("#load-cover").show();
	var linkId = obj.getLinkId();
	var isHide = obj.getIsHide();
	obj.$http.post(obj.URL_PARAM.API + "/cartoonCollection/classify-search"
	,{linkId:linkId,isHide:isHide,pageNo:obj.params.pageNo,pageSize:obj.params.pageSize,keyword:keyword}
	,{emulateJSON:true}).then(function(pay) {
		if(!pay.data.success){
			obj.$message({
				type: 'warning',
        		message: pay.data.info
    		})
			return ;
		}
		$("#load-cover").hide();
		obj.totalPage = pay.data.totalPage;
		obj.cartoonTypeId = pay.data.cartoonTypeId?pay.data.cartoonTypeId:-2;
		obj.recommends = pay.data.recommends;
		if(pay.data.list.length == 0){
			$('.null-div').css('display','block');
			$('.hot-search').hide();
			$('.history').hide();
			$('.works-box').hide();
		}else{
			$('.null-div').hide();
			$('.hot-search').hide();
			$('.history').hide();
			$('.works-box').css('display','block');
			
		}
		
		if(pay.data.totalPage == obj.params.pageNo ){
			$('.no-more').css('display','block');
		}else{
			$('.no-more').hide();
		}
		
		for(var i = 0 ; i < pay.data.list.length;i++){
			obj.cartoonList.push(pay.data.list[i]);
		}
		
		$("#keyword").blur();
		
		obj.loading = false;
		obj.isSearching = false;
	},function(res){
		obj.$message({
			showClose: true,
			type: 'error',
			message:"网络异常，请刷新重试" 
		});
	})
}


export	function delSearchHistory(obj,id){
	obj.$http.post(obj.URL_PARAM.API + "/cartoonCollection/delete-searchHistory"
	,{id:id}
	,{emulateJSON:true}).then(function(pay) {
		if(pay.data.success){
			obj.searchHistorys = [];
			getSearchKeywords(obj);
    		obj.loading = false;
		}else{
			obj.$message({
				type: 'error',
        		message: pay.data.info
    		})
		}
	},function(res){
		obj.$message({
			showClose: true,
			type: 'error',
			message:"网络异常，请刷新重试" 
		});
	})
}

