export function loadTasks(_this){
	var user = window.sessionStorage.getItem('user');
	_this.$http.post(
		_this.URL_PARAM.API + "/taskUser/list",
		{emulateJSON:true}).then(function(response) {
		if(!response.data.success){
     		showMsg(_this,response.data.info,"warning");
     		return ;
		}
		var data = response.data;
		_this.dailyTask = data.dailyTask;
		_this.newTask = data.newTask;
		_this.shareTaskUserItem = data.shareTaskUserItem;
		_this.taskVo = response.data.taskVo;
		var todayTime = data.todayTime;
		todayTimeLeave(_this,todayTime);
	});
}
var setClock;
function todayTimeLeave(_this,todayTime){
	if(_this.dailyTask == null || null == todayTime){
		return ;
	}
	setClock = setInterval(function(){
		var datetime = todayTime+" 23:59:59";
		var timeleave = timeDiffer(datetime,_this);
		$(".todayLeave").html("距离结束还有："+timeleave);
	},1000);
}
function timeDiffer(datetime,_this){
		//如果时间格式是正确的，那下面这一步转化时间格式就可以不用了
    var dateEnd = new Date(datetime.replace(/-/g, "/"));//将-转化为/，使用new Date
    var dateBegin = new Date();//获取当前时间
    var dateDiff = dateEnd.getTime() - dateBegin.getTime();//时间差的毫秒数
    var dayDiff = Math.floor(dateDiff / (24 * 3600 * 1000));//计算出相差天数
    var leave1=dateDiff%(24*3600*1000)    //计算天数后剩余的毫秒数
    var hours=Math.floor(leave1/(3600*1000))//计算出小时数
    //计算相差分钟数
    var leave2=leave1%(3600*1000)    //计算小时数后剩余的毫秒数
    var minutes=Math.floor(leave2/(60*1000))//计算相差分钟数
    //计算相差秒数
    var leave3=leave2%(60*1000)      //计算分钟数后剩余的毫秒数
    var seconds=Math.round(leave3/1000);
    if(dateDiff  <= 0 ){
    	clearClock();
    	_this.loadTasks(this);
    	return "00时00分00秒";
    }
    if(dayDiff<10){
    	return (hours<10?'0':'')+hours+"时"+(minutes<10?'0':'')+minutes+"分"+(seconds<10?'0':'')+seconds+"秒";
    }
	return dayDiff+"天"+(hours<10?'0':'')+hours+"时"+(minutes<10?'0':'')+minutes+"分"+(seconds<10?'0':'')+seconds+"秒";
}
export function clearClock(){
	if(setClock != null){
		clearInterval(setClock); //清除js定时器
	}
}
//领取子项奖励
export function receiveItemReward(_this,taskUserItemId){
	if(_this.isRevicing){
		return ;
	}
	_this.isRevicing = true;
	_this.$http.post(
		_this.URL_PARAM.API + "/taskUser/receiveItemReward",
		{
			taskUserItemId:taskUserItemId
		},
		{emulateJSON:true}).then(function(response) {
			_this.isRevicing = false;
			if(!response.data.success){
	     		showMsg(_this,response.data.info,"warning");
	     		return ;
			}
			var data = response.data;
			_this.recieveCoins = data.recieveCoins;
			_this.rewardShow();
			loadTasks(_this);
			
	});
}
//领取全部奖励
export function receiveReward(_this,taskUserId){
	if(_this.isRevicing){
		return ;
	}
	_this.isRevicing = true;
	_this.$http.post(
		_this.URL_PARAM.API + "/taskUser/receiveReward",
		{
			taskUserId:taskUserId
		},
		{emulateJSON:true}).then(function(response) {
			_this.isRevicing = false;
			if(!response.data.success){
	     		showMsg(_this,response.data.info,"warning");
	     		return ;
			}
			var data = response.data;
			_this.recieveCoins = data.recieveCoins;
			_this.rewardShow();
			loadTasks(_this)
	});
}
function showMsg(_this,msg,type){
	_this.$message({
		showClose: true,
		type: type,
		message:msg 
	});
}
