/**
 * 加载充值设置数据
 */
export function loadRechargeSet(_this){
	$("#load-cover").show();
	var userId = _this.getTouristId();
	_this.$http.post(_this.URL_PARAM.API + "/user/get-charge-set",
		{
			userId:userId
		},
		{emulateJSON:true}).then(function(response) {
		$("#load-cover").hide();
		if(!response.data.success){
     		showMsg(_this,response.data.info,"warning");
     		return ;
		}
		_this.givePercent = response.data.givePercent;
		_this.rechargeText = response.data.rechargeInfo;
		_this.setList = response.data.setList;
		_this.vipSets = response.data.vipSets;
		_this.user = response.data.user;
		_this.isDist = response.data.isDist;
		/*********兑换码活动**********/
		setExchange(_this,response);
		/**********装盘活动*********************/
		setDist(_this,response);
		if(_this.setList != null && _this.setList.length > 0){
			_this.payPrice = _this.setList[0].price;
			var givePriceStr = _this.setList[0].giveCoins;
			_this.orderId =  _this.setList[0].id;
			_this.givePrice = _this.setList[0].giveCoins;
		}
		if(_this.givePercent != null){
			var maxGivePrice = getMaxGivePrice(_this.setList);
			_this.showGiveMoney = Math.floor(_this.givePercent.value)*0.01*maxGivePrice;
			_this.showGiveMoney = _this.showGiveMoney.toFixed(2);
		}
		/*********广告条*********/
		_this.banner = response.data.banner;
		//_this.onload()
	});
}
/**
 * 转盘活动
 */
function setDist(_this,response){
	_this.isDist = response.data.isDist;
	_this.dist = response.data.dist;
	if(!_this.isDist){
		return ;
	}
	_this.remain = _this.dist.distUser==null?0:_this.dist.distUser.nums;
	
	var opt = null;
	var opts = _this.dist.distOptions;
	if(opts == null || opts.length <= 0){
		result_angle[0].p = 0;
		result_angle[1].p = 0;
		result_angle[2].p = 0;
		result_angle[3].p = 0;
		result_angle[4].p = 0;
		result_angle[5].p = 0;
		return ;
	}
	if(_this.dist.distUser != null){
		for(var i = 0 ; i < opts.length ;i++){
			if(opts[i].id == _this.dist.distUser.distOptionId){
				opt = opts[i];
				break;
			}
		}
	}
	if(opt == null){
		opt = opts[0];
	}
	result_angle[0].p = opt.rate5*0.01;
	result_angle[1].p = opt.rate4*0.01;
	result_angle[2].p = opt.rate3*0.01;
	result_angle[3].p = opt.rate2*0.01;
	result_angle[4].p = opt.rate1*0.01;
	result_angle[5].p = opt.rate6*0.01;
}
/*
 * 设置兑换码活动
 */
function setExchange(_this,response){
	_this.isExchange = response.data.isExchange;
	_this.exchangeOption.isHasExchangActivity = response.data.exchangeActivity==null?false:true;
	_this.exchangeActivity = response.data.exchangeActivity;
	addFirstOption(_this);
	checkShowNotice(_this);
}
/**
 * 判断是否显示通知
 * @param {Object} _this
 */
function checkShowNotice(_this){
	var date = new Date();
	var startDate =  new Date("2018/03/02 00:00:00");
	var endDate =  new Date("2018/03/03 23:59:59");
	if(date.getTime() < startDate.getTime() || date.getTime() > endDate.getTime()){
		return ;
	}
	_this.isShowMsg = true;
}
//获取最大的价格
function getMaxGivePrice(setList){
	var maxGivePrice = 0;
	if(setList ==null || setList.length <= 0 ){
		return maxGivePrice;
	}
	for(var i = 0 ; i < setList.length; i++){
		var price = Math.floor(setList[i].price);
		if(maxGivePrice >= price){
			continue;
		}
		maxGivePrice = price;
	}
	return maxGivePrice;
}
/*
 * 设置第一个兑换码
 */
function addFirstOption(_this){
	if(_this.exchangeActivity == null || _this.exchangeActivity.options == null || _this.exchangeActivity.options.length <= 0 ){
		return ;
	}
	var options = _this.exchangeActivity.options;
	for(var i = 0 ; i < options.length ; i ++){
		if(options[i].isExchange != 1){
			continue;
		}
		_this.exchangeOption.activityId = options[i].exchangeActivityId;
		_this.exchangeOption.optionId = options[i].id;
		_this.exchangeOption.isExchange =  options[i].isExchange;
		break;
	}
	
}

function showMsg(_this,msg,type){
	_this.$message({
		showClose: true,
		type: type,
		message:msg 
	});
}

/*轮播广告计时器*/
var clock = "";
export	function clock(){
	clock = setInterval(function(){
		var size = $("#roll-div .roll-items").size();
		$(".roll-items").each(function(){
			var top = $.trim($(this).attr("top"));
			var _this = $(this);
			if(top <= 0){
				top = 0.68*(size-1);
				$(this).animate({top:'-0.68rem'},300);
				setTimeout(function(){
					_this.css("top",top+"rem")
				},400);
			}else{
				top = top - 0.68;
				$(this).animate({top:top+'rem'},300);
			}
			$(this).attr("top",top);
		})
	}, 3000); //一秒执行一次
}
export function clearClock(){
	clearInterval(clock); //清除js定时器
	rotate_angle = 0;
}
/**
 * 领取兑换卷
 */
export function receiveActivity(_this){
	if(_this.exchangeOption.isLoading){
		return ;
	}
	_this.exchangeOption.isLoading = true;
	_this.$http.post(_this.URL_PARAM.API + "/exchangeActivity/receive-activity",
		{
			optionId:_this.exchangeOption.optionId,
			activityId:_this.exchangeOption.activityId
		},
		{emulateJSON:true}).then(function(response) {
		var data = response.data;
		_this.exchangeOption.isLoading = false;
		if(!data.success){
			_this.exchangeOption.exchangeInfo = data.info;
			_this.tcTips();
     		return ;
		}
		var id = data.id;
		_this.goReceiveEnvelopes(id);
	});
}

/***************转盘活动**************/
var result_angle = [{a:0,p:0.166667,t:'200'},{a:60,p:0.166667,t:'100'},{a:120,p:0.166667,t:'66'},{a:180,p:0.166667,t:'50'},{a:240,p:0.166667,t:'30'},{a:300,p:0.166667,t:'莫心灰'}];
var rotate_angle = 0; //起始位置为0
export function calculate_result(during_time,obj){
	var self = this;
    during_time = during_time || 1; // 默认为1s
    
    var rand_num = Math.ceil(Math.random() * 100); // 用来判断的随机数，1-100
    
    var result_index; // 最终要旋转到哪一块，对应result_angle的下标
    var end_pos ;
    var start_pos = end_pos = 0; // 判断的角度值起始位置和结束位置
    
    for(var i in result_angle){
        start_pos = end_pos + 1; // 区块的起始值
        end_pos = end_pos + 100 * result_angle[i].p; // 区块的结束值
        
        if(rand_num >= start_pos && rand_num <= end_pos){ // 如果随机数落在当前区块，那么获取到最终要旋转到哪一块
            result_index = i;
            break;
        }
    }
    
    var rand_circle = Math.ceil(Math.random() * 2) + 3; // 附加多转几圈，2-3
    obj.flag_click = false; // 旋转结束前，不允许再次触发
    rotate_angle =  rotate_angle - rand_circle * 360 - result_angle[result_index].a - rotate_angle % 360;
    $('#J_bg').css({
        'transform': 'rotate('+rotate_angle+'deg)',
        '-ms-transform': 'rotate('+rotate_angle+'deg)',
        '-webkit-transform': 'rotate('+rotate_angle+'deg)',
        '-moz-transform': 'rotate('+rotate_angle+'deg)',
        '-o-transform': 'rotate('+rotate_angle+'deg)',
        'transition': 'transform ease-out '+during_time+'s',
        '-moz-transition': '-moz-transform ease-out '+during_time+'s',
        '-webkit-transition': '-webkit-transform ease-out '+during_time+'s',
        '-o-transition': '-o-transform ease-out '+during_time+'s'
    });
    // 旋转结束后，允许再次触发
    setTimeout(function(){ 
        obj.flag_click = true;
        obj.prizeWindow();
    },during_time*1000);
    // 告诉结果
    var result = result_angle[result_index].t;
    obj.remain--;
    if(/\d/.test(result)){
    	obj.distReward = result+"币";
    } else{
    	result = 0;
    	obj.distReward = "";
    }
    distReward(obj,result);
}
/*
 * 装盘转动
 */
export function go(obj){
    calculate_result(3,obj);
}

//领取幸运转盘活动奖励
function distReward(obj,giveCoins){
	obj.$http.post(obj.URL_PARAM.API + "/user/revieve-dist",
		{
			giveCoins:giveCoins,
			distUserId:obj.dist.distUser.id
		},{emulateJSON:true}).then(function(response) {
			if(!response.data.success){
				showMsg(obj,response.data.info,"warning");
	     		return ;
			}
		});
}