export function login(_this){
	if(_this.isLogining){
		return ;
	}
	var linkId = _this.getLinkId();
	if(linkId == null || linkId == undefined || linkId == "undefined" || linkId == "null"){
		linkId = '';
	}
	_this.isLogining = true;
	_this.$http.post(_this.URL_PARAM.API + "/index/app-login",
	{
		account:_this.account,
		password:_this.password,
		linkId:linkId
	}
	,{
		emulateJSON:true,
		credentials: true
	}).then(function(fam) {
		_this.isLogining = false;
		if(!fam.data.success){
			_this.loginInfo =  fam.data.info;
			_this.tcShow();
			return ;
		}
		if(_this.isFromRegister == null){
			_this.loginInfo = "登录成功";
			_this.tcShow();
		}
		var user = fam.data.user;
		showFirstLogin(_this,user);
		if(user.shareBusinessName != null && user.shareBusinessName != ""){
			_this.COMMON_PARAM.COMMON_TITLE = user.shareBusinessName+"-";
		}
	    var obj = JSON.stringify(user);
		window.sessionStorage.setItem('user',obj);
		if(_this.getUserCookie()){	//未获取到cookie值，设置
			_this.setUserCookie(user.phone);
		}
		_this.$bus.$emit("logByUserLogin");
		//前往绑定手机号
		localDB.deleteSpace(this.$store.state.localDBKey);
		goPage(_this,user);
		_this.$bus.$emit('modifyPushToken');
		/*setTimeout(function(){
			if(_this.COMMON_PARAM.LOGIN_BACK_URL == "" || _this.COMMON_PARAM.LOGIN_BACK_URL == null || _this.COMMON_PARAM.LOGIN_BACK_URL == "undefined"){
				if(_this.isFromRegister == null){
					_this.COMMON_PARAM.LOGIN_BACK_URL = "/user/index";
				}else{
					_this.COMMON_PARAM.LOGIN_BACK_URL = "/index";
				}
			}
        	_this.$router.push(_this.COMMON_PARAM.LOGIN_BACK_URL);
        }, 600);*/
        
	});
}
/**
 * 自动登陆
 */
export function autoLogin(_this){
	if(_this.isLogining){
		return ;
	}
	var linkId = _this.getLinkId();
	if(_this.isEmpty(linkId)){
		linkId = '';
	}
	_this.isLogining = true;
	_this.$http.post(_this.URL_PARAM.API + "/index/autoLogin",
	{
		account:_this.account,
		linkId:linkId,
		loginType:20,
	}
	,{
		emulateJSON:true,
		credentials: true
	}).then(function(fam) {
		_this.isLogining = false;
		if(!fam.data.success){
			//window.location.href = _this.URL_PARAM.MOBILE+_this.loc;
			_this.$router.push(_this.loc);
			return ;
		}
		_this.loginInfo = "登录成功";
		var user = fam.data.user;
		showFirstLogin(_this,user);
		if(user.shareBusinessName != null && user.shareBusinessName != ""){
			_this.COMMON_PARAM.COMMON_TITLE = user.shareBusinessName+"-";
		}
	    var obj = JSON.stringify(user);
		window.sessionStorage.setItem('user',obj);
		_this.$bus.$emit("logByUserLogin");
		//window.location.href = _this.URL_PARAM.MOBILE+_this.loc;
		_this.$router.replace(_this.loc);
		_this.$bus.$emit('modifyPushToken');
	});
}

/**
 * qq自动登陆
 */
export function autoLoginByQQ(_this){
	if(_this.isLogining){
		return ;
	}
	var linkId = _this.getLinkId();
	if(linkId == null || linkId == undefined || linkId == "undefined" || linkId == "null"){
		linkId = '';
	}
	_this.isLogining = true;
	_this.$http.post(_this.URL_PARAM.API + "/index/app-qq-autoLogin",
	{
		QQunionId:_this.qq_union_id,
		QQOpenId:_this.qq_open_id,
		linkId:linkId
	}
	,{
		emulateJSON:true,
		credentials: true
	}).then(function(fam) {
		_this.isLogining = false;
		if(!fam.data.success){
			window.location.href = _this.URL_PARAM.MOBILE+_this.loc;
			return ;
		}
		_this.loginInfo = "登录成功";
		var user = fam.data.user;
		showFirstLogin(_this,user);
		if(user.shareBusinessName != null && user.shareBusinessName != ""){
			_this.COMMON_PARAM.COMMON_TITLE = user.shareBusinessName+"-";
		}
	    var obj = JSON.stringify(user);
		window.sessionStorage.setItem('user',obj);
		_this.$bus.$emit("logByUserLogin");
		_this.$router.replace("/index");
		_this.$bus.$emit('modifyPushToken');
	});
}

function showFirstLogin(_this,user){
	if(user.loginAppReward != null && user.loginAppReward > 0){
		 setTimeout(function(){
	        _this.$bus.$emit('dlgAlertReward',"首次登录APP",user.loginAppReward);
	    }, 900);
	}
}

/**
 * qq授权登录
 */
export function QQauth(_this){
	_this.auth = false;
	plus.nativeUI.showWaiting("登陆中..." );
	_this.$http.post(_this.URL_PARAM.API + "/qq/auth-mobile",
    {
    	userInfo:_this.userInfo,
    	linkId:_this.getLinkId()
    },
	{emulateJSON:true}).then(function(response) {
		plus.nativeUI.closeWaiting();
		_this.auth = true;
		if(!response.data.success){
			_this.loginInfo =  response.data.info;
			_this.tcShow();
			return ;
		}
		showFirstLogin(_this,response.data.user);
		var obj = JSON.stringify(response.data.user);
		window.sessionStorage.setItem('user',obj);
		localDB.setItem(this.SESSION_KEY.QQ_CY_UNION_ID,response.data.user.unionid);
		localDB.setItem(this.SESSION_KEY.QQ_CY_OPEN_ID,response.data.user.authOpenId);
		//前往绑定手机号
		localDB.deleteSpace(this.$store.state.localDBKey);
		_this.$bus.$emit("logByUserLogin");
		goPage(_this,response.data.user);
		_this.$bus.$emit('modifyPushToken');
		/*setTimeout(function(){
			if(_this.COMMON_PARAM.LOGIN_BACK_URL == "" || _this.COMMON_PARAM.LOGIN_BACK_URL == null || _this.COMMON_PARAM.LOGIN_BACK_URL == "undefined"){
				if(_this.isFromRegister == null){
					_this.COMMON_PARAM.LOGIN_BACK_URL = "/user/index";
				}else{
					_this.COMMON_PARAM.LOGIN_BACK_URL = "/index";
				}
			}
        	_this.$router.push(_this.COMMON_PARAM.LOGIN_BACK_URL);
        }, 600);*/
	}).catch(function(res){
		_this.auth = true;
	});
}

export function Wxauth(_this){
	_this.auth = false;
	plus.nativeUI.showWaiting("登陆中..." );
	_this.$http.post(_this.URL_PARAM.API + "/index/auth-weixin",
    {
    	userInfo:_this.userInfo,
    	linkId:_this.getLinkId()
    },
	{emulateJSON:true}).then(function(response) {
		plus.nativeUI.closeWaiting();
		_this.auth = true;
		if(!response.data.success){
			_this.loginInfo =  response.data.info;
			_this.tcShow();
			return ;
		}
		showFirstLogin(_this,response.data.user);
		var obj = JSON.stringify(response.data.user);
		window.sessionStorage.setItem('user',obj);
		localDB.setItem(this.SESSION_KEY.ZS_CY_UNION_ID,response.data.user.unionid);
		localDB.setItem(this.SESSION_KEY.ZS_CY_OPEN_ID,response.data.user.appOpenId);
		//前往绑定手机号
		localDB.deleteSpace(this.$store.state.localDBKey);
		_this.$bus.$emit("logByUserLogin");
		goPage(_this,response.data.user);
		_this.$bus.$emit('modifyPushToken');
	}).catch(function(res){
		_this.auth = true;
	});
}

/**
 * 微信授权
 */
export function autoLoginByWx(_this){
	if(_this.isLogining){
		return ;
	}
	var linkId = _this.getLinkId();
	if(linkId == null || linkId == undefined || linkId == "undefined" || linkId == "null"){
		linkId = '';
	}
	_this.isLogining = true;
	_this.$http.post(_this.URL_PARAM.API + "/index/auto-weixin",
	{
		unionid:_this.wx_union_id,
		linkId:linkId
	}
	,{
		emulateJSON:true,
		credentials: true
	}).then(function(fam) {
		_this.isLogining = false;
		if(!fam.data.success){
			window.location.href = _this.URL_PARAM.MOBILE+_this.loc;
			return ;
		}
		_this.loginInfo = "登录成功";
		var user = fam.data.user;
		showFirstLogin(_this,user);
		if(user.shareBusinessName != null && user.shareBusinessName != ""){
			_this.COMMON_PARAM.COMMON_TITLE = user.shareBusinessName+"-";
		}
	    var obj = JSON.stringify(user);
		window.sessionStorage.setItem('user',obj);
		_this.$bus.$emit("logByUserLogin");
		_this.$bus.$emit('modifyPushToken');
		_this.$router.replace("/index");
	});
}

/**
 * 判断登录之后，跳转的页面
 * @param {Object} _this
 * @param {Object} user
 */
function goPage(_this,user){
	if(user.type == 3 || user.type == 1 || user.isSkipBind == 1){
		return goBackUrl(_this);
	}
	if(user.phone != null && user.phone != ''){
		return goBackUrl(_this);
	}
	//前往绑定手机号
	var fromType = _this.isFromRegister == null?1:2;
	setTimeout(function(){
		_this.$router.replace('/user/bind-phone?fromType='+fromType);
	}, 600);
}

/**
 * 跳转至原来路径
 * @param {Object} _this
 */
function goBackUrl(_this){
	setTimeout(function(){
		if(_this.COMMON_PARAM.LOGIN_BACK_URL == "" || _this.COMMON_PARAM.LOGIN_BACK_URL == null || _this.COMMON_PARAM.LOGIN_BACK_URL == "undefined"){
			if(_this.isFromRegister == null){
				_this.COMMON_PARAM.LOGIN_BACK_URL = "/user/index";
			}else{
				_this.COMMON_PARAM.LOGIN_BACK_URL = "/index";
			}
		}
    	_this.$router.replace(_this.COMMON_PARAM.LOGIN_BACK_URL);
	}, 600);
	
}
