/***********获取用户信息 satrt*****************/
export	function info(obj){
	obj.$http.post(obj.URL_PARAM.API + "/myTime/info",{userId:obj.userId},{emulateJSON:true}).then(function(response) {
		if(response.data.success){
			obj.user = response.data.user;
			if(!response.data.isTrue){
				obj.state = 1;
			}
			var time = response.data.time;
			formatDateTime(obj.user,time);
			calculate(obj.user,time);
		}else{
			this.$message({
				type: 'error',
        		message: response.data.info
    		})
		}
	})
}

function formatDateTime(params,time) {  
    var date = new Date(time); 
    var y = date.getFullYear();    
    var m = date.getMonth() + 1;    
    m = m < 10 ? ('0' + m) : m;    
    var d = date.getDate();    
    d = d < 10 ? ('0' + d) : d;
    params.y = y;
    params.m = m;
    params.d = d;
}

function calculate(user,time){
	var date = new Date(time);  
	date = new Date(date.toLocaleDateString());
	var now = new Date();
	var days = now.getTime() - date.getTime(); 
　　 	user.day = parseInt(days / (1000 * 60 * 60 * 24)); 
	return user.day;
}
/***********获取用户信息 end***********************/
/***********我订阅的第一章漫画 satrt*****************/
export	function subscription(obj){
	obj.$http.post(obj.URL_PARAM.API + "/myTime/subscription",{userId:obj.userId},{emulateJSON:true}).then(function(response) {
		if(response.data.success){
			obj.orderInfo = response.data.orderInfo;
			obj.orderCount = response.data.count;
			obj.chapter = response.data.chapter;
			if(obj.orderCount > 0){
				var time = response.data.time;
				formatDateTime(obj.orderInfo,time);
			}else{
				obj.orderInfo = {};
				formatDateTime(obj.orderInfo,new Date());
			}
		}else{
			this.$message({
				type: 'error',
        		message: response.data.info
    		})
		}
	})
}
/***********我订阅的第一章漫画 end*****************/
/***********收藏漫画 satrt*******************/
export	function collect(obj){
	obj.$http.post(obj.URL_PARAM.API + "/myTime/collect",{userId:obj.userId},{emulateJSON:true}).then(function(response) {
		if(response.data.success){
			obj.collects = response.data.list;
			var length = obj.collects.length;
			for(var i = 0 ; i < 3 ; i++){
				if(length > 0){
					length = length-1;
					obj.latelyCollects[i] = obj.collects[length];
				}
			}
		}else{
			this.$message({
				type: 'error',
        		message: response.data.info
    		})
		}
	})
}
/***********收藏的漫画 end*********************/
/***********点赞次数最多的漫画 satrt*******************/
export	function maxPraise(obj){
	obj.$http.post(obj.URL_PARAM.API + "/myTime/max-praise",{userId:obj.userId},{emulateJSON:true}).then(function(response) {
		if(response.data.success){
			obj.chapterPraise = response.data.chapter;
			if(null != obj.chapterPraise && undefined != obj.chapterPraise && 
				obj.chapterPraise.praiseCount > 0){
				obj.cartoonCollection = response.data.cartoonCollection;
			}
		}else{
			this.$message({
				type: 'error',
        		message: response.data.info
    		})
		}
	})
}
/***********点赞次数最多的漫画 end*********************/

/***********我订阅最多的漫画类型 satrt*******************/
export	function subtMaxType(obj){
	obj.$http.post(obj.URL_PARAM.API + "/myTime/sub-maxType",{userId:obj.userId},{emulateJSON:true}).then(function(response) {
		if(response.data.success){
			obj.subCartoons = response.data.list;
			if( null != obj.subCartoons && undefined != obj.subCartoons && obj.subCartoons.length > 0){
				obj.typeName = obj.subCartoons[0].typeName;
			}
		}else{
			this.$message({
				type: 'error',
        		message: response.data.info
    		})
		}
	})
}
/***********我订阅最多的漫画类型  end*******************/

/***********我的赠币和阅读币 satrt*******************/
export	function sumIncome(obj){
	obj.$http.post(obj.URL_PARAM.API + "/myTime/sumIncome",{userId:obj.userId},{emulateJSON:true}).then(function(response) {
		if(response.data.success){
			obj.readIncome = response.data.readIncome;
			obj.giveIncome = response.data.giveIncome;
		}else{
			this.$message({
				type: 'error',
        		message: response.data.info
    		})
		}
	})
}
/***********我的赠币和阅读币end*******************/