export var wxInitMixin = {
  created:function(){
    // 微信 SDK 认证
    this.isWeixinBrowser = /micromessenger/.test(navigator.userAgent.toLowerCase());
    if(!this.isWeixinBrowser){
    	return ;
    }
    this.$http.post(
    	this.URL_PARAM.WEIXIN + "/wx-config",
    	{emulateJSON:true}).then(function(response) {
		    // success callback
		    if(!response.data.success){
		    	this.tipText = response.data.info;
   				this.showInfo();
   				return ;
		    }
        var wxconfig = {
					debug: false, // 开启调试模式,调用的所有api的返回值会在客户端alert出来，若要查看传入的参数，可以在pc端打开，参数信息会通过log打出，仅在pc端时才会打印。
					appId: response.data.wxConfig.appId, // 必填，公众号的唯一标识
					timestamp: response.data.wxConfig.timestamp, // 必填，生成签名的时间戳
					nonceStr:response.data.wxConfig.nonceStr, // 必填，生成签名的随机串
					signature: response.data.wxConfig.signature, // 必填，签名，见附录1
					jsApiList: [
						'checkJsApi',
						'updateAppMessageShareData',
						'updateTimelineShareData',
						'onMenuShareWeibo',
						'chooseWXPay'
					] // 必填，需要使用的JS接口列表，所有JS接口列表见附录2
				};
        wx.config(wxconfig);
				wx.error(function(res){
					//alert(res.errMsg);
			    // config信息验证失败会执行error函数，如签名过期导致验证失败，具体错误信息可以打开config的debug模式查看，也可以在返回的res参数中查看，对于SPA可以在这里更新签名。
				});
				wx.ready(function() {
         	wx.checkJsApi({
						jsApiList: ['updateAppMessageShareData','updateTimelineShareData','onMenuShareWeibo'], // 需要检测的JS接口列表，所有JS接口列表见附录2,
					
						success: function(res) {
							//alert(res);
					    // 以键值对的形式返回，可用的api值true，不可用为false
					    // 如：{"checkResult":{"chooseImage":true},"errMsg":"checkJsApi:ok"}
				    }
					
					});
					//this.wxShare(config.wxShareTitle,config.wxShareDesc,this.wxShareLink(),config.wxShareImg);
				});
				/*wx.error(function(res){
					//alert(res.errMsg);
				    // config信息验证失败会执行error函数，如签名过期导致验证失败，具体错误信息可以打开config的debug模式查看，也可以在返回的res参数中查看，对于SPA可以在这里更新签名。
				});
				wx.ready(function() {
					readyWxConfig(obj);
					//alert(location.href.split('#')[0])
					//alert("ready");
				});*/
	    });
  },
  methods:{
    // 自定义的分享链接(可选)
    wxShareLink:function(){
      return location.href;
    }
  }
}

/**
 * 初始化微信分享方法全局引入
 */
export var wxShareMixin = {
  methods:{
  	wxShareLink:function(){
      return location.href;
    },
    isWxBrowse:function(){
    	return /micromessenger/.test(navigator.userAgent.toLowerCase());
    },
    //设置默认的分享
  	wxShareByDefault:function(){
	    if(!this.isWxBrowse()){
	    	return ;
	    }
  		var user = JSON.parse(window.sessionStorage.getItem('user'));
  		if(null == user){
  			 this.wxShare(this.$store.state.wxShare.default.title,this.$store.state.wxShare.default.desc,
  		 		this.$store.state.wxShare.default.link,this.$store.state.wxShare.default.imgUrl);
  			 return ;
  		}
	 	var linkId = null;
	 	var params = "?shareUserId="+user.id;
	 	if(user != null && user.linkId != null && user.linkId != "0" && user.linkId != 0){
	 		params += "&linkId="+user.linkId;
	 	}
	 	var link = this.$store.state.wxShare.default.link+params;
  		this.$store.commit('setWxShareByDefault',null,null,link,null);
  		this.wxShare(this.$store.state.wxShare.default.title,this.$store.state.wxShare.default.desc,
  		 		this.$store.state.wxShare.default.link,this.$store.state.wxShare.default.imgUrl);
  	},
  	//普通设置分享
  	wxShareByCommon:function(title,desc,link,imgUrl){
  		 var user = JSON.parse(window.sessionStorage.getItem('user'));
  		if(null == user){
  			 this.wxShare(this.$store.state.wxShare.default.title,this.$store.state.wxShare.default.desc,
  		 		this.$store.state.wxShare.default.link,this.$store.state.wxShare.default.imgUrl);
  			 return ;
  		}
	 	var linkId = null;
	 	var params = "?shareUserId="+user.id;
	 	if(user != null && user.linkId != null && user.linkId != "0" && user.linkId != 0){
	 		params += "&linkId="+user.linkId;
	 	}
  		this.$store.commit('setWxShareByCommon',title,desc,link==null?null:link+params,imgUrl);
  		this.wxShare(title,desc,link+params,imgUrl);
  	},
  	versionCompare:function(v1, v2, options) {
		    var lexicographical = options && options.lexicographical,
		        zeroExtend = options && options.zeroExtend,
		        v1parts = v1.split('.'),
		        v2parts = v2.split('.');
		
		    function isValidPart(x) {
		        return (lexicographical ? /^\d+[A-Za-z]*$/ : /^\d+$/).test(x);
		    }
		
		    if (!v1parts.every(isValidPart) || !v2parts.every(isValidPart)) {
		        return NaN;
		    }
		
		    if (zeroExtend) {
		        while (v1parts.length < v2parts.length) v1parts.push("0");
		        while (v2parts.length < v1parts.length) v2parts.push("0");
		    }
		
		    if (!lexicographical) {
		        v1parts = v1parts.map(Number);
		        v2parts = v2parts.map(Number);
		    }
		    for (var i = 0; i < v1parts.length; ++i) {
		        if (v2parts.length == i) {
		            return 1;
		        }
		
		        if (v1parts[i] == v2parts[i]) {
		            continue;
		        }
		        else if (v1parts[i] > v2parts[i]) {
		            return 1;
		        }
		        else {
		            return -1;
		        }
		    }
		
		    if (v1parts.length != v2parts.length) {
		        return -1;
		    }
		    return 0;
		},
		getCurWxVersion:function(){
			var wechatInfo = navigator.userAgent.match("/MicroMessenger\\/([\\d\\.]+)/i");
			if( !wechatInfo ) {
			  return null ;
			}
			return wechatInfo[1];
		},
    wxShare:function(title, desc, link, imgUrl) {
      // 加载微信分享方法
      wx.ready(function() {
        /*if(wx.updateAppMessageShareData){
        		//自定义“分享给朋友”及“分享到QQ”按钮的分享内容
	        wx.updateAppMessageShareData({ 
		        title: title, // 分享标题
		        desc: desc, // 分享描述
		        link: link, // 分享链接，该链接域名或路径必须与当前页面对应的公众号JS安全域名一致
		        imgUrl: imgUrl, // 分享图标
					}, function(res) { 
					}); 
        }else{
        	wx.onMenuShareTimeline({
		        title: title, // 分享标题
		        desc: desc, // 分享描述
		        link:link, // 分享链接
		        imgUrl: imgUrl, // 分享图标
		        success: function () {
		         //alert("分享到朋友圈成功")       
        		},
		        trigger: function (res) {    
		        //alert('用户点击发送给朋友');   
		        	//统计点击数
		        }, 
    				fail: function (res) {    
           		// alert(JSON.stringify(res));    
		        },  
		        cancel: function () {
		          //alert("分享失败,您取消了分享!")
		        }
	      	});
	      	wx.onMenuShareQQ({
						title: title, // 分享标题
						desc: desc, // 分享描述
						link: link, // 分享链接
						imgUrl: imgUrl, // 分享图标
						success: function () {
						// 用户确认分享后执行的回调函数
						},
						cancel: function () {
						// 用户取消分享后执行的回调函数
						}
					});
        }
        if(wx.updateTimelineShareData){
        	wx.updateTimelineShareData({ 
		        title: title, // 分享标题
		        link: link, // 分享链接，该链接域名或路径必须与当前页面对应的公众号JS安全域名一致
		        imgUrl: imgUrl, // 分享图标
					}, function(res) { 
						//这里是回调函数 
					}); 
        }else{
        	//微信分享菜单测试
		      wx.onMenuShareAppMessage({
		        title: title, // 分享标题
		        desc: desc, // 分享描述
		        link:link, // 分享链接
		        imgUrl: imgUrl, // 分享图标
		        success: function () {
		             //alert("成功分享给朋友")
		        },
		        trigger: function (res) {    
		       		//alert('用户点击发送给朋友'); 
		        }, 
		    		fail: function (res) {    
		         	//alert(JSON.stringify(res));    
		        },   
		        cancel: function () {
		         	//alert("分享失败,您取消了分享!")
		        }
		      });
        }*/
        //自定义“分享给朋友”及“分享到QQ”按钮的分享内容
        wx.updateAppMessageShareData({ 
	        title: title, // 分享标题
	        desc: desc, // 分享描述
	        link: link, // 分享链接，该链接域名或路径必须与当前页面对应的公众号JS安全域名一致
	        imgUrl: imgUrl, // 分享图标
		}, function(res) { 
		}); 
        wx.updateTimelineShareData({ 
	        title: title, // 分享标题
	        link: link, // 分享链接，该链接域名或路径必须与当前页面对应的公众号JS安全域名一致
	        imgUrl: imgUrl, // 分享图标
		}, function(res) { 
			//这里是回调函数 
		}); 
    	
	    	/*wx.onMenuShareTimeline({
	        title: title, // 分享标题
	        desc: desc, // 分享描述
	        link:link, // 分享链接
	        imgUrl: imgUrl, // 分享图标
	        success: function () {
	         //alert("分享到朋友圈成功")       
					},
	        trigger: function (res) {    
	        	//alert('用户点击发送给朋友');   
	        	//统计点击数
	        }, 
					fail: function (res) {    
	   				// alert(JSON.stringify(res));    
	        },  
	        cancel: function () {
	          //alert("分享失败,您取消了分享!")
	        }
	  		});
		  	wx.onMenuShareQQ({
						title: title, // 分享标题
						desc: desc, // 分享描述
						link: link, // 分享链接
						imgUrl: imgUrl, // 分享图标
						success: function () {
						// 用户确认分享后执行的回调函数
						},
						cancel: function () {
						// 用户取消分享后执行的回调函数
						}
				});
				//微信分享菜单测试
			  wx.onMenuShareAppMessage({
			    title: title, // 分享标题
			    desc: desc, // 分享描述
			    link:link, // 分享链接
			    imgUrl: imgUrl, // 分享图标
			    success: function () {
			         //alert("成功分享给朋友")
			    },
			    trigger: function (res) {    
			   		//alert('用户点击发送给朋友'); 
			    }, 
					fail: function (res) {    
			     	//alert(JSON.stringify(res));    
			    },   
			    cancel: function () {
			     	//alert("分享失败,您取消了分享!")
			    }
			  });*/
			  
		  });
  	},
  	//微信支付
  	wxPay:function(){
  		var cartoonId = 0;
			var orderId = 0 ;
			if(this.isRechargePage){
				orderId   = this.orderId;
				cartoonId = this.cartoonId;
			}else{
				orderId   = this.selectParams.id;
				cartoonId = this.rechargeParams.cartoonId;
			}
			var _this = this;
		  _this.$http.post(
				_this.URL_PARAM.API + "/weixin/pay/weixin-pay",
				{
					orderId:orderId,
					cartoonId:cartoonId
				},
				{emulateJSON:true}).then(function(response) {
			    if(!response.data.success){
			    	_this.payFlag = true;
			    	if(!_this.isRechargePage){
			    		alert(data.info);
			    		return ;
			    	}
			    	_this.tipText = response.data.info;
						_this.showInfo();
						return ;
			    }
		    	wx.chooseWXPay({
						"appId": response.data.appId,
						"timestamp": response.data.timestamp, // 支付签名随机串，不长于 32 位
						"nonceStr": response.data.nonceStr, // 支付签名随机串，不长于 32 位
						"package": response.data.packageStr, // 统一支付接口返回的prepay_id参数值，提交格式如：prepay_id=***）
						"signType": 'MD5',
						"paySign": response.data.paySign,
						success: function (res) {
						if(!_this.isRechargePage){
							_this.unlockChapter();
							return ;
						}
						_this.tipText = "充值成功";
						_this.showInfo();
		    		_this.payFlag = false;
					},cancel: function (res) {
						_this.payFlag = false;
					},error:function(res){
						_this.payFlag = false;
					}
				 });
		    });
  	}
	}
}
