//需要myStorage.js文件
//需要json2.js文件
/**
 * obj={
 * 	key://唯一值
 * }
 */
/*if(! (myStorage && JSON)){
    alert("需要myStorage.js和json2.js两个文件");
}*/
 
window.localDB = (new (function(){
	var myStorage;
	var maxLength = 1000;
    //创建一个空间，参数为空间名
    this.init = function(){
    	myStorage = window.plus?plus.storage:null;
    };
    this.createSpace = function(space_name){
		this.init();
		if(!myStorage){
			return false;
		}
        if( typeof(space_name)!=="string" ){
            console.log("space_name参数需为字符串");
            return false;
        }
        //如果还没有数据库空间管理器，新建一个，否则检测空间管理器中是否已存在同名的空间
        if(!myStorage.getItem("localSpaceDB")){
            var space_obj = [];
            var space_json = JSON.stringify(space_obj);     //转化对象为JSON格式
            myStorage.setItem("localSpaceDB", space_json);
 
            console.log("新建localSpaceDB成功");
        }
 
        //取出所有空间名，空间名存在JSON中，所以需要转化成JS对象
        var space_obj = JSON.parse(myStorage.getItem("localSpaceDB"));
 		
 		console.log("space_obj:"+myStorage.getItem("localSpaceDB"));
        //检查对象是否存在空间名
        if(space_obj){
        	for(var i=0; i<space_obj.length; i++){
	            if(space_obj[i].spaceName == space_name){
	                console.log("已存在空间名"+space_name+"，新建失败");
	                return false;   //如果已存在空间名，退出函数，返回失败值
	            }
       	 	}
        }
 
        //空间管理器localSpaceDB登记新空间
        var new_obj = {     //将空间名保存在新对象中
            spaceName : space_name
        };
        if(!space_json){
        	space_json = [];
        }
        space_json.push( new_obj );
        var new_space_json = JSON.stringify(space_json);
        myStorage.setItem("localSpaceDB", new_space_json);
 
        //新建一个变量名为space_name的值的空间
        var data_obj = [];
        var data_json = JSON.stringify(data_obj);
        myStorage.setItem(space_name, data_json);
        console.log("新建"+space_name+"空间成功");
        return true;
    };
 
 
    //删除一个空间，参数为空间名
    this.deleteSpace = function(space_name){
    	this.init();
        if(!myStorage){
			return false;
		}
        if( typeof(space_name)!=="string" ){
            console.log("space_name参数需为字符串");
            return false;
        }
        //判断是否删除的依据变量
        var isDelete = false;
        //空间管理器待删除的空间名的下标
        var delIndex = -1;
        //是否存在空间管理器localSpaceDB
        if(!myStorage.getItem("localSpaceDB")){
        	myStorage.removeItem(space_name);
        	return false;
        }
        //获取空间管理器中所有空间名字的json数据并转化为js对象
        var all_space_name_obj = JSON.parse(myStorage.getItem("localSpaceDB"));
        //检测是否存在space_name值的空间名，记录删除信息
        for(var i=0; i<all_space_name_obj.length; i++){
            if(all_space_name_obj[i].spaceName == space_name){
                isDelete = true;
                delIndex = i;
            }
        }
        //确定是否删除
        if(isDelete === true && delIndex !== -1){
            all_space_name_obj.splice(delIndex, 1);     //删除空间名
            var new_space_json = JSON.stringify(all_space_name_obj);    //转换对象为JSON
            //更新空间管理器信息
            myStorage.setItem("localSpaceDB", new_space_json);
            //删除空间
            myStorage.removeItem(space_name);
            console.log("成功删除"+space_name+"空间");
            return true;
        }
        console.log("删除空间失败，不存在"+space_name+"空间");
        myStorage.removeItem(space_name);
        return false;
    };
 
    //插入数据，参数分别为空间名、插入的对象（不单纯用值来表示，用对象来表示数据）
    this.insert = function(space_name, obj_data){
    	this.init();
        if(!myStorage){
			return false;
		}
        //检测是否存在空间
        if(!myStorage.getItem(space_name)){
           this.createSpace(space_name);
        }
        //获取空间存储的数据
        var all_data = JSON.parse(myStorage.getItem(space_name));
        if(!all_data){
        	all_data = [];
        }
        if(all_data.length >= maxLength){
        	console.log("存储数据的长度已经达到最大："+maxLength);
        	return false;
        }
        //插入数据
        all_data.push(obj_data);
        myStorage.setItem(space_name, JSON.stringify(all_data));
 
        console.log("已插入数据："+obj_data+"，所有数据如下：");
        console.dir(all_data);
        return true;
    };
 
    //按照key更新
    this.update = function(space_name, obj_key, obj_replace){
    	//先删除
    	this.delete(space_name, obj_key);
    	//在添加
        return this.insert(space_name,obj_replace);
    };
 
    //按照key删除
    this.delete = function(space_name, obj_key){
    	this.init();
        if(!myStorage){
			return false;
		}
        //检测是否存在空间
        if(!myStorage.getItem(space_name)){
            console.log("不存在"+space_name+"空间");
        	return false;
        }
        var all_data = JSON.parse(myStorage.getItem(space_name));
        var new_data = [];
       //条件查找
        for(var i=all_data.length-1; i>=0; i--){
            //如果格式相同，检测值相等情况
            if( typeof(all_data[i]) === typeof(obj_key) ){
                if(JSON.stringify(all_data[i]) === JSON.stringify(obj_key) ){
                    //如果找到，保存到结果集
                    //select_result.push(new productObj(i,all_data[i]));
                    continue;
                }
                new_data.push(all_data[i]);
                continue;
            }
            if( typeof(all_data[i]) !== "number" ||
                typeof(all_data[i]) !== "boolean" ||
                typeof(all_data[i]) !== "string"){
                var isDel = false;
                for( var x in all_data[i]){
                    if(typeof(all_data[i][x]) !== typeof(obj_key)){
                        continue;
                    }
                    if(JSON.stringify(all_data[i][x]) === JSON.stringify(obj_key) ){
                        //如果找到，保存到结果集
                        //select_result.push(new productObj(i,all_data[i]));
                        isDel = true;
                        break;
                    }
                }
                if(isDel){
                	continue;
                }
                new_data.push(all_data[i]);
                continue;
            }
            new_data.push(all_data[i]);
        }
        //更新空间
        myStorage.setItem(space_name, JSON.stringify(new_data));
    };
 
    //查询函数，参数为字符串或数字或数组或布尔型，或对象的属性，返回一个结果数组
    this.select = function(space_name, select_value, is_select_all){
    	is_select_all = is_select_all==null?false:is_select_all;
    	select_value = select_value==null?"":select_value;
    	this.init();
        if(!myStorage){
			return [];
		}
        if(!myStorage.getItem(space_name)){
            console.log("不存在"+space_name+"空间");
            return [];
        }
        //初始化结果数组
        var select_result = [];
 
        //生产存储于结果数组中的对象
        function productObj(row, ob){
            return ({
                At : row,
                Obj : ob
            });
        };
 
        //获取space_name空间的所有数据对象
        var all_data = JSON.parse(myStorage.getItem(space_name));
 
        //如果存在查询条件
        if(!select_value){
            return select_result;
        }
        //是否查找全部
        if(is_select_all === true){
            for(var i=all_data.length-1; i>=0; i--){
                //全部查找，生成结果集
                select_result.push(new productObj(i,all_data[i]));
            }
            if(select_result.length>0){
	            console.log("查询到结果");
	            console.dir(select_result);
	        }else{
	            console.log("没查询到结果");
	        }
            return select_result;
        }
        //条件查找
        for(var i=all_data.length-1; i>=0; i--){
            //如果格式相同，检测值相等情况
            if( typeof(all_data[i]) === typeof(select_value) ){
                if(JSON.stringify(all_data[i]) === JSON.stringify(select_value) ){
                    //如果找到，保存到结果集
                    select_result.push(new productObj(i,all_data[i]));
                }
            }
            if( typeof(all_data[i]) !== "number" ||
                typeof(all_data[i]) !== "boolean" ||
                typeof(all_data[i]) !== "string"){
                for( var x in all_data[i]){
                    if(typeof(all_data[i][x]) === typeof(select_value)){
                    	console.log(JSON.stringify(all_data[i][x]));
                        if(JSON.stringify(all_data[i][x]) === JSON.stringify(select_value) ){
                            //如果找到，保存到结果集
                            select_result.push(new productObj(i,all_data[i]));
                        }
                    }
                }
            }
        }
        if(select_result.length>0){
            console.log("查询到结果");
            console.dir(select_result);
        }else{
            console.log("没查询到结果");
        }
        //返回结果集
        return select_result;
    };
    
     //查询函数，参数为字符串或数字或数组或布尔型，或对象的属性，返回一个结果数组
    this.page = function(space_name, pageNo, pageSize){
    	this.init();
    	if(!myStorage){
			return [];
		}
        if(!myStorage.getItem(space_name)){
            console.log("不存在"+space_name+"空间");
            return [];
        }
        var startIndex = (pageNo-1)*pageSize; 
        var endIndex = pageNo*pageSize-1;
        //初始化结果数组
        var select_result = [];
 
        //生产存储于结果数组中的对象
        function productObj(row, ob){
            return ({
                At : row,
                Obj : ob
            });
        };
 
        //获取space_name空间的所有数据对象
        var all_data = JSON.parse(myStorage.getItem(space_name));
        if(all_data.length < startIndex){
        	if(select_result.length>0){
	            console.log("查询到结果");
	            console.dir(select_result);
	        }else{
	            console.log("没查询到结果");
	        }
        	return select_result;
        }
        if(all_data.length <= endIndex){
        	for(var i=all_data.length-1; i>=startIndex; i--){
        	 	select_result.push(new productObj(i,all_data[i]));
        	}
        	 if(select_result.length>0){
	            console.log("查询到结果");
	            console.dir(select_result);
	        }else{
	            console.log("没查询到结果");
	        }
        	return select_result;
        }
        for(var i = endIndex;i>= startIndex;i--){
    	 	select_result.push(new productObj(i,all_data[i]));
    	}
        if(select_result.length>0){
            console.log("查询到结果");
            console.dir(select_result);
        }else{
            console.log("没查询到结果");
        }
        //返回结果集
        return select_result;
    };
    
    //查询函数，参数为字符串或数字或数组或布尔型，或对象的属性，返回一个结果数组
    this.getItem = function(space_name){
    	this.init();
        if(!myStorage){
			return null;
		}
        if(!myStorage.getItem(space_name)){
            return null;
        }
        return myStorage.getItem(space_name);
    };
    
    this.setItem = function(space_name,space_value){
		this.init();
		if(!myStorage){
			return null;
		}
        if(typeof(space_name)!=="string" ){
            console.log("space_name参数需为字符串");
            return null;
        }
        //如果还没有数据库空间管理器，新建一个，否则检测空间管理器中是否已存在同名的空间
        if(!myStorage.getItem("localSpaceDB")){
            var space_obj = [];
            var space_json = JSON.stringify(space_obj);     //转化对象为JSON格式
            myStorage.setItem("localSpaceDB", space_json);
            console.log("新建localSpaceDB成功");
        }
 		this.createSpace(space_name);
        //新建一个变量名为space_name的值的空间
        myStorage.setItem(space_name, space_value);
        console.log("新建"+space_name+"空间成功");
        return true;
    };
    this.createSpace = function(space_name){
    	this.init();
		if(!myStorage){
			return false;
		}
    	//取出所有空间名，空间名存在JSON中，所以需要转化成JS对象
        var space_obj = JSON.parse(myStorage.getItem("localSpaceDB"));
        //检查对象是否存在空间名
        if(space_obj){
        	 for(var i=0; i<space_obj.length; i++){
	            if(space_obj[i].spaceName == space_name){
	                console.log("已存在空间名"+space_name+"，新建失败");
	                return false;   //如果已存在空间名，退出函数，返回失败值
	            }
	        }
        }else{
        	space_obj = [];
        }
       
        //空间管理器localSpaceDB登记新空间
        var new_obj = {     //将空间名保存在新对象中
            spaceName : space_name
        };
        space_obj.push( new_obj );
        var new_space_json = JSON.stringify(space_obj);
        myStorage.setItem("localSpaceDB", new_space_json);
        return true;
    }
 
})());